def load_data(filename):
    f = open(filename)
    sites = {}
    
    for row in f:
        if not row.startswith("LINK"):
            continue
        data = row.split()            
        resid,resnum = data[2],data[3]
        het = data[5] + "_" +  data[6]
        dist = data[-1]
        if not sites.has_key(het):
            sites[het] = []
        sites[het].append((resid,resnum,dist))
    
    f.close()
    return sites


def compute_stats(ligands):
    
    avgdist=0
    residues={}

    for (resid,resnum,dist) in ligands:
        avgdist += float(dist)
        if not residues.has_key(resid):
            residues[resid] = 1
        else:
            residues[resid] += 1
    
    return avgdist/len(ligands), residues


def print_stats(sites):
    for name,ligands in sites.items():
        avgdist,residues = compute_stats(ligands)
        print "%s\t%.2f\t" %(name,avgdist) + "\t",
        print residues


def stats4chain(data):
    chains = {}
    # merge sites in same chain
    for het,ligands in data.items():
        chain = het.split("_")[1][0]
        if not chains.has_key(chain):
            chains[chain] = []
        chains[chain].extend(ligands)
    return chains

filename=raw_input("insert file name: ")

sites=load_data(filename)
print("SITE\tAVG_DIST\tLIGANDS")
print_stats(sites)
chains=stats4chain(sites)
print("CHAIN\tAVG_DIST\tLIGANDS")        
print_stats(chains)


