
def read_data(filename):
	f = open(filename)
	genes = f.readline().strip().split()
	values_by_label = {}

	for line in f:
		data = line.strip().split()
		label = data[-1]
		values = [float(v) for v in data[:-1]]
		if label not in values_by_label:
			values_by_label[label] = {}
		for i in range(len(values)):
			if genes[i] not in values_by_label[label]:
				values_by_label[label][genes[i]] = [values[i]]
			else:
				values_by_label[label][genes[i]].append(values[i])

	return values_by_label

def mean(values):
	m = 0.
	for v in values:
		m += v
	return m / len(values)


def mean_differences(values_by_label):
	diffs = []
	labels = list(values_by_label.keys())
	first_gene2vals = values_by_label[labels[0]]
	second_gene2vals = values_by_label[labels[1]]

	for gene in first_gene2vals.keys():
		first_mean = mean(first_gene2vals[gene])
		second_mean = mean(second_gene2vals[gene])
		diffs.append((first_mean-second_mean, gene))

	return diffs

def print_discriminative_genes(diffs, thres):
	diffs.sort()
	diffs.reverse()
	print("\n".join(["%s : %.3f" %(g,v) for v,g in diffs[:thres]]))

filename=input("Inserire nome file: ")
threshold = int(input("Inserire numero geni: "))

values_by_label = read_data(filename)
diffs = mean_differences(values_by_label)
print_discriminative_genes(diffs, threshold)

